# Constrained Latent Action Policies for Model-Based Offline Reinforcement Learning
___

### Installation
___

    1) create a virtual env with python3.9
    python3.9 -m venv clap_venv
    source clap_venv/bin/activate

    3) install requirements via
    pip install -r requirements.txt


### Setup ```hydra/meta/settings.yaml```
___

Update ```local_output_path``` to a directory where you like to store local experiments.

    # Use absolute paths only
    local_output_path: <OUTPUTS_DIR>

Update ```wandb_key``` if you want to log experiments using wandb.

Execute ```export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/home/$USER/.mujoco/mujoco210/bin``` and 
        ```export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/usr/lib/nvidia```


### Commands
___
General command to run the training
```python -m rlab_jax.train CONFIG```

Replace CONFIG with one of {plas, mobile, mopo, lompo, offlinedv2, clap, clap_visual}

Under ```hydra/benchmark``` you can find the hyper-parameter options for all methods, which need to be updated in the respective CONFIG.

### V-D4RL
___

To run image based experiments you first need to download and convert the V-D4RL dataset.

    1) Follow the instructions on https://github.com/conglu1997/v-d4rl to download the dataset from google drive
    2) Use npz_to_hdf5.py to convert the datasets to a single hdf5 file. Make sure to adapt input_dir, output_dir and output_name in the script
    3) Always update experiment.dataset_path in the CONFIG file if you run an experiment 


