import equinox as eqx


class Module(eqx.Module):
    subclasses = {}

    def __init_subclass__(cls, **kwargs):
        super().__init_subclass__(**kwargs)
        if hasattr(cls, "_MODULE_TYPE"):
            cls.subclasses[cls._MODULE_TYPE] = cls

    @classmethod
    def create(
        cls,
        type,
        from_cfg=False,
        *args,
        **kwargs,
    ):
        if type not in cls.subclasses:
            raise ValueError(f"Bad module type {type}")

        if from_cfg:
            return cls.subclasses[type].from_cfg(*args, **kwargs)

        return cls.subclasses[type](*args, **kwargs)

    def __call__(self, *args, **kwargs):
        return
