import chex
import equinox as eqx
import jax.numpy as jnp
import optax
import equinox as eqx

@chex.dataclass
class Reconstruction:
    observation: jnp.array
    action: jnp.array


@chex.dataclass
class Prediction:
    posterior: jnp.array
    prior: jnp.array
    reconstruction: jnp.array

@chex.dataclass
class ModulesState:
    agent_state: eqx.Module
    model_state: eqx.Module
    reward_state: eqx.Module
    ensemble_state: eqx.Module

    def __init__(self, agent_state=None, model_state=None, reward_state=None, ensemble_state=None):
        self.agent_state = agent_state
        self.model_state = model_state
        self.reward_state = reward_state
        self.ensemble_state = ensemble_state
