from rlab_jax.modules.agents.sac import SACAgent, SACAgentState
import chex
import equinox as eqx
import jax
import jax.numpy as jnp
import omegaconf
import optax

from rlab_jax.modules.agents.agent import Agent
from rlab_jax.modules.networks import Mlp, Module
from rlab_jax.rlab_dataclasses import TrainState, Transition, random_variable
from rlab_jax.utils.keygen import keygen
from rlab_jax_projects.latent_actions.modules.mbpo_ensemble import ScalerTrainState
from rlab_jax_projects.latent_actions.modules.agents.mobile import MobileAgent


class MOPOAgent(MobileAgent):
    _AGENT_TYPE = "MOPOAgent"

    def penalty(self, policy: Module, target_critic: Module, model_state: ScalerTrainState, dream_batch: Transition, key: jax.random.PRNGKey):
        next_observation_dist = self.observation_predict_fn(model_state=model_state, observation=dream_batch.observation, action=dream_batch.action, key=key, return_dist=True)

        next_observation_std = next_observation_dist.std()[..., :-1]

        return jnp.expand_dims(jnp.max(jnp.linalg.norm(next_observation_std, axis=-1), axis=0), -1)
